VERSION 5.00
Begin VB.Form frmTextFileViewer 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Text File Viewer"
   ClientHeight    =   9105
   ClientLeft      =   2115
   ClientTop       =   1125
   ClientWidth     =   11370
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9105
   ScaleWidth      =   11370
   Begin VB.TextBox txtFileContent 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4935
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   7
      Top             =   4080
      Width           =   11235
   End
   Begin VB.FileListBox filTextFileViewer 
      Height          =   3015
      Left            =   3180
      TabIndex        =   2
      Top             =   480
      Width           =   8115
   End
   Begin VB.DriveListBox drvSelDrive 
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   480
      Width           =   3075
   End
   Begin VB.DirListBox dirSelDir 
      Height          =   2340
      Left            =   60
      TabIndex        =   0
      Top             =   1140
      Width           =   3075
   End
   Begin VB.Label Label4 
      BackStyle       =   0  'Transparent
      Caption         =   "Files in:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3180
      TabIndex        =   9
      Top             =   0
      Width           =   675
   End
   Begin VB.Label Label3 
      BackStyle       =   0  'Transparent
      Caption         =   "Selected File:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   8
      Top             =   3600
      Width           =   1695
   End
   Begin VB.Label lblSelectedFileName 
      BackStyle       =   0  'Transparent
      Caption         =   "XXXXXXXXXXXXXXXXXX"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   6
      Top             =   3840
      Width           =   11295
      WordWrap        =   -1  'True
   End
   Begin VB.Label lblCurrentDir 
      BackStyle       =   0  'Transparent
      Caption         =   "XXXXXXXXXXXXXXXXXXXXXXXX"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   3180
      TabIndex        =   5
      Top             =   240
      Width           =   8175
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label2 
      BackStyle       =   0  'Transparent
      Caption         =   "Directories:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   4
      Top             =   900
      Width           =   2535
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Drive:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   240
      Width           =   2535
   End
End
Attribute VB_Name = "frmTextFileViewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Form-level variable to indicate last valid drive selected ...
Private mstrDrive   As String

'-----------------------------------------------------------------------------
Private Sub Form_Load()
'-----------------------------------------------------------------------------
        
    ' Initialize the DriveListBox to point to the C: drive ...
    drvSelDrive.Drive = "C:"
    
    ' Likewise for the "mstrDrive" variable ...
    mstrDrive = "C:"
    
    ' Set the path of the DirListBox to point to the root of C:
    dirSelDir.Path = "C:\"

End Sub

'-----------------------------------------------------------------------------
Private Sub drvSelDrive_Change()
'-----------------------------------------------------------------------------
    
    ' An error would occur if you attempted to change to a CD or floppy drive
    ' where the media was not ready ...
    
    On Error Resume Next
    
    ' When the drive changes, set the Path of the DirListBox to point to the
    ' the newly selected drive ...
    dirSelDir.Path = drvSelDrive.Drive
    
    If Err.Number <> 0 Then
        ' There was a problem with the drive - most likely a CD or floppy drive was
        ' selected, but there was no CD or disk in the drive.
        ' Inform the user ...
        MsgBox "Drive selected is unavailable.", vbInformation, "Drive Unavailable"
        ' Reset the Drive property of the DriveListBox to the last valid drive ...
        drvSelDrive.Drive = mstrDrive
    Else
        ' Drive change was OK, update the "mstrDrive" variable with the newly
        ' selected drive ...
        mstrDrive = drvSelDrive.Drive
    End If
    
End Sub

'-----------------------------------------------------------------------------
Private Sub dirSelDir_Change()
'-----------------------------------------------------------------------------
    
    ' The path of the DirListBox has changed, so set the path of the FileListBox
    ' to point to the new path of the DirListBox. This action alone will cause the
    ' contents FileListBox to refresh.
    filTextFileViewer.Path = dirSelDir.Path
    
    ' Update the label caption to reflect the new directory path ...
    lblCurrentDir.Caption = dirSelDir.Path
    
    ' Test the ListCount property of the FileListBox to see if there are any files
    ' in the current path ...
    If filTextFileViewer.ListCount > 0 Then
        ' There is at least one file in the current path, so highlight (select) the
        ' first file by setting ListIndex to 0. This will invoke the filTextFileViewer_Click
        ' event ...
        filTextFileViewer.ListIndex = 0
    Else
        ' There are no files in the current path ...
        lblSelectedFileName.Caption = "(None)"
        txtFileContent.Text = ""
    End If
    
End Sub

'-----------------------------------------------------------------------------
Private Sub dirSelDir_Click()
'-----------------------------------------------------------------------------

    ' Coding the Click event for the DirListBox with the code below will force
    ' the dirSelDir_Change event (by setting the Path property to the List property
    ' of the currently clicked item). Without doing this, the change event would
    ' only occur when user DOUBLE-CLICKS a new directory in the DirListBox.
    ' Invoking the Change on a single-click seems more natural.
    
    ' Note: Unlike other list controls, the List property of the DirListBox holds
    ' not just the text that is displayed in the control, but also the text of its
    ' of parent paths. For example, if the currently selected entry in a DirListBox
    ' was a directory called "CesarFTP" below the "Program Files" directory below the
    ' "C:" drive, the contents of that selected List entry would be
    ' "C:\Program Files\CesarFTP" - NOT JUST "CesarFTP".
    
    With dirSelDir
        .Path = .List(.ListIndex)
    End With

End Sub

'-----------------------------------------------------------------------------
Private Sub filTextFileViewer_Click()
'-----------------------------------------------------------------------------

    Dim strFileExt      As String
    Dim strCurrFile     As String
    Dim strFileContent  As String
    Dim intFreeFile     As Integer
    Dim lngFileLen      As Long
    Dim lngX            As Long
    Dim blnIsTextFile   As Boolean
    
    ' If no files are selected from the FileListBox (ListIndex = -1),
    ' then get out because there's nothing to do ...
    If filTextFileViewer.ListIndex = -1 Then Exit Sub
    
    ' Form a fully-qualified file name by concatenating the Path property
    ' of the FileListBox with the text of the currently selected entry (which
    ' is the filename). If the path already has a backslash at the end of it
    ' (as it would for a root directory), fine, otherwise add a backslash to the
    ' end of it before concatenating it with the filename ...
    With filTextFileViewer
        strCurrFile = IIf(Right$(.Path, 1) = "\", .Path, .Path & "\") _
                    & .List(.ListIndex)
    End With
    
    ' Update the label caption to reflect the new filename ...
    lblSelectedFileName.Caption = strCurrFile
    
    ' Use the FileLen function to get the length of the current file ...
    lngFileLen = FileLen(strCurrFile)
    
    ' Test the file length ...
    If lngFileLen >= 65536 Then
        ' Too big for the textbox, so just display the message ...
        txtFileContent.Text = "*** Selected file is too large to be displayed. ***"
    Else
        ' Read the entire contents of the file into a string variable ("strFileContent") ...
        intFreeFile = FreeFile
        Open strCurrFile For Binary Access Read As #intFreeFile
        strFileContent = Input(LOF(intFreeFile), intFreeFile)
        Close #intFreeFile
        ' Loop thru the file content byte-by-byte to test for characters that would
        ' "disqualify" the file from being regarded as a "plain-text" file. For our
        ' purposes, the ASCII characters 0 thru 8, 11 thru 12, and 14 thru 31 would
        ' disqualify the file.
        blnIsTextFile = True
        For lngX = 1 To lngFileLen
            Select Case Asc(Mid$(strFileContent, lngX, 1))
                Case 0 To 8, 11 To 12, 14 To 31
                    blnIsTextFile = False
                    Exit For
            End Select
        Next
        ' Done with the loop, so test the result ...
        If blnIsTextFile Then
            ' All characters were valid, so assign the contents of the file to the
            ' Text property of the textbox ...
            txtFileContent.Text = strFileContent
        Else
            ' We encountered a disqualifying character, so dispaly a message rather
            ' than the contents of the file ...
            txtFileContent.Text = "*** Selected file is not a plain text file. ***"
        End If
    End If
    
End Sub
